/*
 * NetworkAdvancedView.java
 * 
 * Copyright (c) 2003-2004 Digi International
 * This program and the information contained in it is confidential and
 * proprietary to Digi International and may not be used, copied, or re-
 * produced without the prior written permission of Digi International.
 * 
 */

package com.digi.config.ui;

import com.digi.config.core.*;
import com.digi.config.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;




/** 
 * This class is a view panel that shows a basic serial 
 * informational panel for the ConnectMe device
 * 
 * This view can be embedded in other panels as desired.
 */


public class NetworkAdvancedView extends ConfigViewImpl {
    /** A KvpNode that holds just the fields used in this view */
    KvpNode viewSettingTree;
    /** listens to the device for changes to fields */
    DeviceChangeListener settingChangeListener;
    /** Panel that holds the view content */
    GridContentPanel content;

    // Data Fields currently used in this view
    KvpField ethernetSpeedKvpField;
    KvpField ethernetModeKvpField;
    KvpField parityKvpField;
    KvpField stopbitsKvpField;
    KvpField flowcontrolKvpField;

    // UI Controls for each field
    JComboBox ethernetSpeed_UIC;
    JComboBox ethernetMode_UIC;

    /**
     * Basic constructor. Sets up the tree view and the edit panel.
     */
    public NetworkAdvancedView() throws Exception {
        // create the KvpNode and the settings change listener
        viewSettingTree = new KvpNode();
        settingChangeListener = new DeviceChangeListener() {
            public void deviceChanged(DeviceChangeEvent e) {
                //SystemLog.debug("NetworkAdvancedView was notified that device settings changed");
                refreshViewData();
                refreshViewControls();
            }
        };
        // Create the panel that will hold the view controls
        content = new GridContentPanel(this.getName(),1);
        // create a listener that will detect when a user edits the field values
        ControlChangeAdapter fieldListener = new ControlChangeAdapter() {
            public void changePerformed(Object source, ActionEvent ae, FocusEvent fe) {
                //SystemLog.debug("NetworkAdvancedView was notified that field "+source.toString()+" changed.");
                if (source==ethernetSpeed_UIC) {
                    ethernetSpeedKvpField.setStringValue(ethernetSpeed_UIC.getSelectedItem().toString());
                } else if (source==ethernetMode_UIC) {
                    ethernetModeKvpField.setStringValue(ethernetMode_UIC.getSelectedItem().toString());
                }
            }
        };

        //
        // Create the fields and put them on the view
        //

        String ethernetSpeedChoices[] = {"auto", "10", "100"};
        ethernetSpeed_UIC = content.addJComboBox("EthernetSpeed", "EthernetSpeedDesc", ethernetSpeedChoices, fieldListener);
        String ethernetModeChoices[] = {"auto", "full", "half"};
        ethernetMode_UIC = content.addJComboBox("EthernetMode","EthernetModeDesc",ethernetModeChoices,fieldListener);

        content.addVGlue();
    }

    /**
     * Returns a one word name identifying this view. 
     */
    public String getName() {
        return "NetworkAdvancedView";
    }

    /** 
     * Return the Component that displays the primary content for this view
     */
    public Component getViewContent() {
        return content;
    }


    /**
     * Informs view what device to work with. View should flush any
     * cached device data and mark current view content as invalid
     * so that it is refreshed appropriatly.
     */
    public void setDevice(Device newDevice) {
        super.setDevice(newDevice);
        refreshViewData();
        refreshViewControls();
        device.addSettingChangeListener(settingChangeListener);
    }

    /** 
     * Refreshes the local copy of the kvpGroup displayed in the view. The updated kvpGroup come
     * from those currently cached in the Device
     */
    private void refreshViewData() {
        viewSettingTree.clear();
        ethernetSpeedKvpField = viewSettingTree.mergeFrom(device.getInternalSettingTree(), "boot", "eth_speed"); 
        ethernetModeKvpField = viewSettingTree.mergeFrom(device.getInternalSettingTree(), "boot", "eth_duplex"); 
    }

    /** 
     * Refreshes the state of the controls in the view to match the data in the views kvpGroup.
     */
    private void refreshViewControls() {
        ethernetSpeed_UIC.setEnabled(ethernetSpeedKvpField!=null);
        if (ethernetSpeedKvpField!=null) {
            ethernetSpeed_UIC.setSelectedItem(ethernetSpeedKvpField.getStringValue());
        }
        ethernetMode_UIC.setEnabled(ethernetModeKvpField!=null);
        if (ethernetModeKvpField!=null) {
            ethernetMode_UIC.setSelectedItem(ethernetModeKvpField.getStringValue());
        }
    }


    /**
     * This method is called to instruct the view that it is about to be made
     * active. When a view is active it needs to make sure its content is correct.
     * An example of why a panel may be inactive is if it were on a tabbed pane 
     * and was not currently visible or if the user selected some other view.
     */
    public void activate() {
        SystemLog.debug("Activating "+getName());
    }

    /**
     * This method is called to instruct the view that it is about to be made
     * inactive. When a view is inactive, it does not need to worry
     * about maintaining its content in a correct state. An example of why a panel
     * may be inactive is if it were on a tabbed pane and was not currently visible
     * or if the user selected some other view.
     */
    public void deactivate() {
        SystemLog.debug("Deactivating "+getName());
    }

    /**
     * Indicates if any changes have been made by the user that have not yet been
     * saved to the device(ie committed).
     */
    public boolean isChanged() {
        return viewSettingTree.hasChanged();
    }

    /**
     * This method instructs the view to place any changes the user has made within 
     * the view into the provided clusters. Once the changes have been saved to
     * to the device, a subsequent call to commitChanges() will be made.
     */
    public void getChanges(KvpNode settingCluster, KvpNode stateCluster) {
        // Merge the view changes into the provided cluster
        settingCluster.merge(viewSettingTree, false);
    }

    /**
     * Instructs the view to consider any user changes within the view as 
     * saved to the device (ie committed).
     */
    public void commitChanges() {
        // simply reset flags indicating user changes in the contols
        viewSettingTree.resetChanged();
    }

    /** 
     * Instructs the view to discard any changes the user has made within the
     * view and revert those fields to the original state. The view is also 
     * free to refresh all its fields to the present cached state of the device at 
     * this time.
     */
    public void cancelChanges() {
        refreshViewData();
        refreshViewControls();
    }


}

